package domain;

public class DistanzMatrix extends MatrixN {
	public DistanzMatrix(int dim) throws MatrixException {
		super(dim);
	}
	
	@Override
	public void set(int row, int col, int value) throws MatrixException {
		if (value < -1)
			throw new MatrixException("Fehler: nur Werte ab -1 erlaubt!");
		if (row==col && value!=0)
			throw new MatrixException("Fehler: in der Diagonale nur 0 erlaubt!");
			
		super.set(row, col, value);
	}
	
	public void ubernehme(Adjazenz a) throws MatrixException {
		if (getDimension() != a.getDimension())
			throw new MatrixException("Fehler: Dimension nicht gleich!");
		
		for (int z=0; z<a.getDimension(); z++) {
			for (int s=0; s<a.getDimension(); s++) {
				if (z!=s) {
					if (a.get(z, s) != 0) {
						set(z, s, a.get(z, s));
					}
					else {
						set(z, s, -1);						
					}
				}
			}
		}
	}

	public void ubernehme(Potenz p, int stufe) throws MatrixException {
		if (getDimension() != p.getDimension())
			throw new MatrixException("Fehler: Dimension nicht gleich!");
		
		for (int z=0; z<p.getDimension(); z++) {
			for (int s=0; s<p.getDimension(); s++) {
				if ((get(z, s) == -1) && (p.get(z, s) > 0)) {
					set(z, s, stufe);
				}
			}
		}
	}
}


















