package test;

import domain.Adjazenz;
import domain.DemoMatrix;
import domain.DistanzMatrix;
import domain.MatrixAlgorithmen;
import domain.MatrixException;

public class TestAlgorithmen {
	public static void main(String[] args) {
		testDistanz();
	}

	private static void testDistanz() {
		Adjazenz a;
		DistanzMatrix erg;
		
		try {
			a = new Adjazenz(3);
			a.importMatrixN("a_3_01.txt");
			System.out.println(a);
			erg = new DistanzMatrix(3);
			MatrixAlgorithmen.berechneDistanzmatrix(a, erg);
			System.out.println(erg);
		}
		catch (MatrixException e) {
			System.err.println(e.getMessage());			
		}
	}

	
	private static void testMultiply() {
		DistanzMatrix d1, d2;
		DemoMatrix erg;
		
		try {
			d1 = new DistanzMatrix(3);
			d1.importMatrixN("d_3_01.txt");
			System.out.println(d1);
			d2 = new DistanzMatrix(3);
			d2.importMatrixN("d_3_02.txt");
			System.out.println(d2);
			erg = new DemoMatrix(3);
			MatrixAlgorithmen.multiply(d1, d2, erg);
			// 18	4	3
			//  4	0	0
			//  3	0	0
			System.out.println(erg);
		}
		catch (MatrixException e) {
			System.err.println(e.getMessage());			
		}
	}

	
	private static void testAdd() {
		DistanzMatrix d1, d2, erg;
		
		try {
			d1 = new DistanzMatrix(2);
			d1.importMatrixN("d_2_01.txt");
			d2 = new DistanzMatrix(2);
			d2.importMatrixN("d_2_02.txt");
			erg = new DistanzMatrix(2);
			MatrixAlgorithmen.add(d1, d2, erg);
			System.out.println(erg);
			// 0 8
			// 8 0
		} catch (MatrixException e) {
			System.err.println(e.getMessage());
		}
		
		try {
			d1 = new DistanzMatrix(3);
			d1.importMatrixN("d_3_01.txt");
			d2 = new DistanzMatrix(3);
			d2.importMatrixN("d_3_02.txt");
			erg = new DistanzMatrix(3);
			MatrixAlgorithmen.add(d1, d2, erg);
			// 0 5 7
			// 5 0 3
			// 7 3 0
			System.out.println(erg);
		} catch (MatrixException e) {
			System.err.println(e.getMessage());
		}

	}
}
